const logger = require('../common/logger.js');
const express = require('express');
const port = 3000;

function launcher() {
    const app = express();
    logger.debug('express', `Express started on localhost:${port}`);

    var publicRouter = require('./routes/public.js');

    app.set('views', `${__dirname}/views`);
    app.set('view engine', 'ejs');
    app.use(express.static(`${__dirname}/../style`));
    app.use('/', publicRouter);

    app.listen(port, () => {
        logger.info('express', `Express listening on port ${port}`);
    });
}

launcher();
