const ini = require('ini'),
    os = require('os'),
    fs = require('fs');

const __configDir = `${os.homedir()}/.config/lektor`;
const __configFile = `${__configDir}/amadeus.ini`;

fs.mkdirSync(__configDir, { recursive: true });
__dir = fs.opendirSync(__configDir);
__dir.close(err => {
    if (err) throw err;
});

var config = {
    database: null,
    host: null,
    port: null,
    loglevel: null,
    loglektord: null,
    attachmode: null,
    reload() {
        var fd = fs.openSync(__configFile, 'a');
        fs.close(fd, err => {});
        var __config = ini.parse(fs.readFileSync(__configFile, 'utf-8'));

        __config.database ??= {};
        __config.lektord ??= {};
        __config.log ??= {};

        __config.log.level ??= 'debug';
        __config.log.lektord ??= true;
        __config.database.path ??= '/home/kara/kara.db';
        __config.lektord.host ??= 'localhost';
        __config.lektord.port ??= '6600';
        __config.lektord.attach ??= true;

        this.database = __config.database.path;
        this.host = __config.lektord.host;
        this.port = __config.lektord.port;
        this.attachmode = __config.lektord.attach;
        this.loglevel = __config.log.level;
        this.loglektord = __config.log.lektord;

        fs.writeFileSync(__configFile, ini.stringify(__config));

        this.flush();
    },
    flush() {
        const __config = {
            database: {
                path: this.database,
            },
            lektord: {
                host: this.host,
                port: this.port,
                attach: this.attachmode,
            },
            log: {
                level: this.loglevel,
                lektord: this.loglektord,
            },
        };
        fs.writeFileSync(__configFile, ini.stringify(__config));
    },
};

config.reload();
module.exports = global.config = module.exports = config;
